//<c>   Copyright 1997-1999 by Gerry J. Danen; all rights reserved.

//<t>   Set login user id in msmail.ini

#include"gd_tools.h"
#include"gd_nw.h"


#define pgVERS_ "V2.00"
#define pgTITL_ "Set Microsoft Mail Login UserID"
#define pgCOPR_ "1997"


UCHAR   iniSec[]="Microsoft Mail", iniFld[]="Login",
        iniFile[]="MSMAIL.INI", iniBak[]="MSMAIL.DI$",
        iFile[FS_LEN], oFile[FS_LEN], work[1001], work1[1001],
        oldName[256], newName[256] ;


void    fix_ini_file( void )
{
    UCHAR       sectionID[81], *w ;
    FILE        *iFh, *oFh ;
    BOOL        ynInserting = FALSE, inSection = FALSE, ynUpdated = FALSE ;
    int         xcnt=0 ;

    fl_parse_ini( iniFile, iniSec, iniFld, work, &xcnt );
    if ( xcnt == 0 )
        ynInserting = TRUE ;
    if ( strlen(work) )
        strcpy( oldName, work );
    else
        strcpy( oldName, "<not defined>" );

    if ( ! strlen(newName) )
    {
        printf( "Current MSMail user is %s\n", oldName );
        exit( GOOD_EXIT );
    }

    if ( st_eq(oldName, newName) )
    {
        printf( "MSMail user is already set to %s. Nothing done!\n", oldName );
        exit( GOOD_EXIT );
    }

    fl_delete( iniBak );
    fl_rename( iniFile, iniBak );

    if ( ( iFh = fopen( iniBak, "r" ) ) == NULL )
    {
        sprintf( work, "$ %s failed to update %s (could not open %s)",
                 get_global_program_name(), iniFile, iniBak );
        nw_logmsg( work );
        fl_rename( iniBak, iniFile );
        exit( BAD_EXIT );
    }

    if ( ( oFh = fopen( iniFile, "w" ) ) == NULL )
    {
        sprintf( work, "$ %s failed to update %s (could not open %s)",
                 get_global_program_name(), iniFile, iniFile );
        nw_logmsg( work );
        fl_rename( iniBak, iniFile );
        exit( BAD_EXIT );
    }

    sprintf( sectionID, "[%s]", iniSec );

    while ( fgets( work, (sizeof(work)-1), iFh ) )
    {
        st_trim( work );
        if ( work[0] == '[' )
        {
            inSection = FALSE ;
            if ( st_eq(work, sectionID) )
                inSection = TRUE ;
        }

        if ( inSection )                        // see if we need to fix
        {
            strcpy( work1, work );
            w = strchr( work1, '=' );
            if ( w != NULL )
                *w = EOS ;
            if ( st_eq(work1, iniFld) )
            {
                sprintf( work, "%s=%s", iniFld, newName );
                ynUpdated = TRUE ;
            }
        }

        fprintf( oFh, "%s\n", work );           // write the line back out

        if ( inSection )                        // see if we need to insert
        {
            if ( ynInserting )
            {
                fprintf( oFh, "%s=%s\n", iniFld, newName );
                ynUpdated = TRUE ;
            }
        }
    }

    fcloseall();

    if ( ynUpdated )                            // feedback re update action
    {
        printf( "%s updated successfully\n", iniFile );
        printf( "Old user is %s\n", oldName );
        printf( "New user is %s\n", newName );
    }
    else
        printf( "%s not updated!\a\n", iniFile );
}


void    main( int argc, char *argv[] )
{
    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    CmdLine( newName );                         // get the command line
    st_trim( newName );

    if ( ! fl_exist( iniFile) )
    {
        logon(1);
        printf( "Can't find %s.\a Are you in the right directory!?\n", iniFile );
        exit( BAD_EXIT );
    }

    fix_ini_file();

    exit( GOOD_EXIT );
}
